﻿using System.Diagnostics;
using System.IO;
using System.Windows;
using Microsoft.Win32;

internal static class Program
{
    [STAThread]
    public static void Main()
    {
        var doesCheck = Process.GetCurrentProcess().MainModule!.FileName.Contains("nocheck");
        if (!doesCheck)
        {
            if (!PseudoDRM())
                return;
        }
        
        Console.WriteLine("Downloading Dependencies");
        var setupProcess = Process.Start(new ProcessStartInfo
        {
            FileName = Path.Combine(".Reloaded-II", "setup.exe"),
            Arguments = "--nogui --nostartreloaded --installdir \"FlatOut 2 FOJ Edition/.Reloaded-II\"",
            Verb = "runas"
        });
        setupProcess.WaitForExit();

        File.Delete(".Reloaded-II/Setup.exe");
        MoveDirectoryContents(".Reloaded-II", "FlatOut 2 FOJ Edition/.Reloaded-II");

        File.WriteAllText("FlatOut 2 FOJ Edition/.Reloaded-II/portable.txt", string.Empty);

        Process.Start(new ProcessStartInfo
        {
            FileName = Path.GetFullPath("FlatOut 2 FOJ Edition/.Reloaded-II/Reloaded-II.exe"),
            UseShellExecute = true
        });

        Thread.Sleep(1000);
        Directory.Delete(Path.GetFullPath(".Reloaded-II"), true);
        Directory.Delete(Path.GetFullPath("Installer Source Code"), true);
        Process.Start("explorer.exe", Path.GetFullPath("FlatOut 2 FOJ Edition"));
        DeleteSelf();
    }

    private static void MoveDirectoryContents(string sourceDir, string targetDir)
    {
        var dir = new DirectoryInfo(sourceDir);

        if (!dir.Exists)
            throw new DirectoryNotFoundException($"Source directory not found: {sourceDir}");

        var dirs = dir.GetDirectories();
        foreach (var subdir in dirs)
        {
            var targetSubdirPath = Path.Combine(targetDir, subdir.Name);
            Directory.CreateDirectory(targetSubdirPath);
            MoveDirectoryContents(subdir.FullName, targetSubdirPath);
        }

        var files = dir.GetFiles();
        foreach (var file in files)
        {
            var targetFilePath = Path.Combine(targetDir, file.Name);
            file.MoveTo(targetFilePath);
        }
    }

    private static bool PseudoDRM()
    {
        MessageBox.Show("Select FlatOut2.exe in your game directory.");
        var filePath = ShowOpenFileDialog();
        if (string.IsNullOrEmpty(filePath))
        {
            MessageBox.Show("No File Selected.");
            return false;
        }

        var directory = Path.GetDirectoryName(filePath)!;
        var bfsFilePath = Path.Combine(directory, "fo2a.bfs");

        if (!File.Exists(bfsFilePath))
        {
            MessageBox.Show("Error: \"fo2a.bfs\" not found in the selected directory.");
            return false;
        }

        return true;
    }

    private static void DeleteSelf()
    {
        var info = new ProcessStartInfo();
        info.Arguments = "/C choice /C Y /N /D Y /T 5 & Del Setup.exe";
        info.WindowStyle = ProcessWindowStyle.Hidden;
        info.CreateNoWindow = true;
        info.FileName = "cmd.exe";
        Process.Start(info);
    }

    private static string? ShowOpenFileDialog()
    {
        var openFileDialog = new OpenFileDialog();
        openFileDialog.InitialDirectory = "c:\\";
        openFileDialog.Filter = "exe files (*.exe)|*.exe";
        openFileDialog.FilterIndex = 2;
        openFileDialog.RestoreDirectory = true;

        var result = openFileDialog.ShowDialog();
        if (result.HasValue && result.Value)
            return openFileDialog.FileName;

        return null!;
    }
}